//actual code starts at 278 (control+g)
//from ringslinger neo
local drawammobar = function(v, player, mo, cam)
	local maxammo = 20
	local curammo = player.powers[pw_underwater]/TICRATE
	local x = 160
	local y = 115
	local barx = x - maxammo/2
	local bary = y + 8
	local patch1 = v.cachePatch("SBARSEG1") //blue
	local patch3 = v.cachePatch("SBARSEG3") //black
	local patch5 = v.cachePatch("SBARSEG5") //red
	
		v.drawScaled((barx-6)*(FRACUNIT), (y+10)*(FRACUNIT)+(FRACUNIT/3), FRACUNIT/2, v.cachePatch("BUBLA0"), V_HUDTRANS|V_PERPLAYER,v.getColormap(nil, nil))
		--Ammo bar
		local pos = 0
		while (pos < maxammo)
			local patch = patch3
			pos = $ + 1
			
				if pos <= curammo
					if pos > curammo - 1
						if (curammo <= 1)
							//first
							if player.powers[pw_underwater] <= 11*TICRATE
							and leveltime % 4 == 0
								patch = patch5
							else
								patch = patch1
							end
						else
							//fill
							if player.powers[pw_underwater] <= 11*TICRATE
							and leveltime % 4 == 0
								patch = patch5
							else
								patch = patch1
							end
						end
					else
						//the one at the right end
						if player.powers[pw_underwater] <= 11*TICRATE
						and leveltime % 4 == 0
							patch = patch5
						else
							patch = patch1
						end
					end
				end
			v.draw(barx + pos - 1, bary, patch, V_HUDTRANS|V_PERPLAYER)
		end
		
end
local drawdivecancelbar = function(v, p, me,soap)
	local maxammo = 16*3
	local curammo = (16-soap.divecancel)*3
	local x = 190
	local y = 105-6
	local barx = x - maxammo/2
	local bary = y
	local patch1 = v.cachePatch("CANSEG1") //blue
	local patch3 = v.cachePatch("CANSEG2") //black
	
		--Ammo bar
		local pos = 0
		while (pos < maxammo)
			local patch = patch3
			pos = $ + 1
			
			
				if pos <= curammo
					v.draw(barx + pos - 1, bary, patch3, V_HUDTRANS|V_PERPLAYER)
					if pos > curammo - 1
						if (curammo <= 1)
							//first
							patch = patch1
						else
							//fill
							patch = patch1
						end
					else
						patch = patch1
					end
				end
			v.draw(barx + pos - 1, bary, patch, V_HUDTRANS|V_PERPLAYER,v.getColormap(nil,me.color))
		end
		
end
local drawcosmenuwaitbar = function(v,p,soap)
	local maxammo = (TICRATE*3/2)*2
	local curammo = soap.cosmenuwait*2
	local x = 160
	local y = 150
	local barx = x - maxammo/2
	local bary = y + 8
	local patch1 = v.cachePatch("COSSEG1") //black
	local patch2 = v.cachePatch("COSSEG2") //green
	
		--Ammo bar
		local pos = 0
		while (pos < maxammo)
			local patch = patch1
			local flags = V_PERPLAYER|V_50TRANS
			local color = 0
			pos = $ + 1
			
				if pos <= curammo
					if pos > curammo - 1
						if (curammo <= 1)
							//first
							patch = patch2
							flags = $ & ~V_50TRANS
						else
							//fill
							patch = patch2
							flags = $ & ~V_50TRANS
						end
					else
						//the one at the right end
						patch = patch2
						flags = $ & ~V_50TRANS
					end
					
					if soap.cosmenuwait >= (TICRATE*3/2)
					and (leveltime % 5) == 0
						color = ColorOpposite(p.skincolor)
					else
						color = p.skincolor
					end

				end
			v.draw(barx + pos - 1, bary, patch, flags,v.getColormap(nil,color) )
			if soap.cosmenuwait >= (TICRATE*3/2)
				v.drawString(x,bary+1,"Spin + C3: Open Cosmetics Menu",V_ALLOWLOWERCASE,"small-center")
			end
		end
		
end
local drawcosbar = function(v,p,x,y,text,color,barflag,textflag,texttype,x2,y2)
	if textflag == nil
		textflag = 0
	end
	if barflag == nil
		barflag = 0
	end
	local ty = 0
	if texttype == nil
		texttype = "thin-center"
	elseif texttype == "small-center"
		ty = 2
	end
	x2 = $ or 0
	y2 = $ or 0
	v.drawScaled(x*FRACUNIT+x2, y*FRACUNIT+y2, FRACUNIT/5, v.cachePatch("COSBAR"), V_10TRANS|barflag, v.getColormap(nil, color))
	v.drawString(x+14, y+3+ty, text, V_ALLOWLOWERCASE|textflag, texttype)
end
local drawcoscursor = function(v,p,x,y,color)
	if color == nil
		color = SKINCOLOR_SUPERGOLD4
	end
	v.drawScaled(x*FRACUNIT, y*FRACUNIT, FRACUNIT/5, v.cachePatch("COSCUR"), 0, v.getColormap(nil, color))
end
local drawcosmenu = function(v,p,soap,cosspace,cosinc,disp)
	v.drawScaled(94*FRACUNIT, 25*FRACUNIT, (FRACUNIT*5)+(FRACUNIT/3), v.cachePatch("SOAPBACK"),V_30TRANS, v.getColormap(nil, SKINCOLOR_BLACK))
	
	local maxpage = 2
	if soap.isElevated then maxpage = 4 end
	
	if soap.cosmenupage == 0
	v.drawString(145+15, 53-disp, "Soap Settings",V_ALLOWLOWERCASE|V_PERPLAYER, "center")
	elseif soap.cosmenupage == 1
	v.drawString(145+15, 53-disp, "Soap's Cosmetics",V_ALLOWLOWERCASE|V_PERPLAYER, "center")
	elseif ((soap.cosmenupage == 2) or (soap.cosmenupage == 3))
	v.drawString(145+15, 53-disp, "Admin Only Stuff",V_ALLOWLOWERCASE|V_PERPLAYER, "center")
	v.drawString(145+15, 53+8-disp, "\x86N\x80 buttons are \x86netvars\x80.",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")
	end
	
if soap.cosmenupage == 0
	if not soap.disableMomen
		drawcosbar(v,p,100+15,100-cosspace-disp,1,SKINCOLOR_LAVENDER)
	else
		drawcosbar(v,p,100+15,100-cosspace-disp,0,SKINCOLOR_AZURE)
	end
	v.drawString(115+15, 100-25-disp, "Momentum",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	if soap.rolltrol
		drawcosbar(v,p,160+15,100-cosspace-disp,soap.rolltrol,SKINCOLOR_PERIDOT)
	else
		drawcosbar(v,p,160+15,100-cosspace-disp,soap.rolltrol,SKINCOLOR_APPLE)
	end
	v.drawString(175+15, 100-25-disp, "Rolltrol",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	//next row
	if soap.soapUncurl
		drawcosbar(v,p,130+15,100+cosspace-disp,soap.soapUncurl,SKINCOLOR_WAVE)
	else
		drawcosbar(v,p,130+15,100+cosspace-disp,soap.soapUncurl,SKINCOLOR_VAPOR)
	end
	v.drawString(145+15, 100-25+cosinc-disp, "Uncurl",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	v.drawString(145+15, 100+cosspace+(cosinc)-disp, "Press \x86WEAPON NEXT",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")
	v.drawString(145+15, 100+cosspace+(cosinc)-disp+8, "to flip the page!",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

//PAGE 1
elseif soap.cosmenupage == 1
	if soap.cosquakes
		drawcosbar(v,p,100+15+soap.hudquakeshakex,100-cosspace+soap.hudquakeshakey-disp,soap.cosquakes,SKINCOLOR_BRONZE)
	else
		drawcosbar(v,p,100+15,100-cosspace-disp,soap.cosquakes,SKINCOLOR_BROWN)
	end
	v.drawString(115+15, 100-25-disp, "Quakes",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	if soap.cosspinglow
		drawcosbar(v,p,160+15,100-cosspace-disp,soap.cosspinglow,SKINCOLOR_GREEN,V_ADD)
	else
		drawcosbar(v,p,160+15,100-cosspace-disp,soap.cosspinglow,SKINCOLOR_FOREST)
	end
	v.drawString(175+15, 100-25-disp, "Spin Glow",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	//next row
	if soap.cosbuttered
		drawcosbar(v,p,100+15,100+cosspace-disp,soap.cosbuttered,SKINCOLOR_YELLOW,nil,nil,nil)
	else
		drawcosbar(v,p,100+15,100+cosspace-disp,soap.cosbuttered,SKINCOLOR_APRICOT)
	end
	v.drawString(115+15, 100-25+cosinc-disp, "Butter Slopes",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	if soap.cosflashes
		drawcosbar(v,p,160+15,100+cosspace-disp,soap.cosflashes,SKINCOLOR_AETHER,soap.hudflashespulse)
	else
		drawcosbar(v,p,160+15,100+cosspace-disp,soap.cosflashes,SKINCOLOR_SLATE,V_TRANS50)
	end
	v.drawString(175+15, 100-25+cosinc-disp, "Flashes",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	//next row
	if soap.cosspeedometer == 1
		drawcosbar(v,p,100+15,100+cosspace+(cosinc)-disp,"FRACs",SKINCOLOR_RUBY)
	elseif soap.cosspeedometer == 2
		drawcosbar(v,p,100+15,100+cosspace+(cosinc)-disp,"FRAC/FRAC",SKINCOLOR_FLAME,nil,nil,"small-center")
	elseif soap.cosspeedometer == 0
		drawcosbar(v,p,100+15,100+cosspace+(cosinc)-disp,"Off",SKINCOLOR_SILVER)
	else
		drawcosbar(v,p,100+15,100+cosspace+(cosinc)-disp,"?",SKINCOLOR_GREY)
	end
	v.drawString(115+15, 100-25+(cosinc*2)-disp, "Speedometer",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	if soap.cosclocksound
		drawcosbar(v,p,160+15,100+cosspace+(cosinc)-disp-soap.hudclocksounddisp,soap.cosclocksound,SKINCOLOR_KETCHUP)
	else
		drawcosbar(v,p,160+15,100+cosspace+(cosinc)-disp,soap.cosclocksound,SKINCOLOR_GOLD)
	end
	v.drawString(175+15, 100-25+(cosinc*2)-disp, "Clocksound",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")


	if soap.costrailstyle == 1
		drawcosbar(v,p,130+15,100+cosspace+(cosinc*2)-disp,"Vanilla",SKINCOLOR_GREEN,nil,nil,"small-center")
	elseif soap.costrailstyle == 2
		drawcosbar(v,p,130+15,100+cosspace+(cosinc*2)-disp,"ffoxD",SKINCOLOR_SAPPHIRE)
	else
		drawcosbar(v,p,130+15,100+cosspace+(cosinc*2)-disp,"?",SKINCOLOR_GREY)
	end
	v.drawString(145+15, 100-25+(cosinc*3)-disp, "Trail Style",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

//PAGE 2
elseif soap.cosmenupage == 2
	if SoapFetchConstant("soap_allbuff")
		drawcosbar(v,p,100+15,100-cosspace-disp,SoapFetchConstant("soap_allbuff"),SKINCOLOR_AZURE)
	else
		drawcosbar(v,p,100+15,100-cosspace-disp,SoapFetchConstant("soap_allbuff"),SKINCOLOR_LAVENDER)
	end
	v.drawString(115+15, 100-25-disp, "\x86N\x80 CBW B. Buff",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")
	
	if soap.nerfed
		drawcosbar(v,p,160+15,100-cosspace-disp,0,SKINCOLOR_OLIVE)
	else
		drawcosbar(v,p,160+15,100-cosspace-disp,1,SKINCOLOR_SANDY)
	end
	v.drawString(175+15, 100-25-disp, "CBW B. Buff",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	//new row
	if SoapFetchConstant("soap_nerfcurl")
		drawcosbar(v,p,100+15,100+cosspace-disp,SoapFetchConstant("soap_nerfcurl"),SKINCOLOR_COPPER)
	else
		drawcosbar(v,p,100+15,100+cosspace-disp,SoapFetchConstant("soap_nerfcurl"),SKINCOLOR_SUNSET)
	end
	v.drawString(115+15, 100-25+cosinc-disp, "\x86N\x80 CBW B. Curl",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	if SoapFetchConstant("soap_yellowdemon")
		drawcosbar(v,p,160+15,100+cosspace-disp,tostring(SoapFetchConstant("soap_yellowdemon")),SKINCOLOR_GOLD)
	else
		drawcosbar(v,p,160+15,100+cosspace-disp,tostring(SoapFetchConstant("soap_yellowdemon")),SKINCOLOR_SUPERRUST5)
	end
	v.drawString(175+15, 100-25+cosinc-disp, "\x86N\x80 Yellow Demon",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	//new row
	if SoapFetchConstant("soap_devmode")
		drawcosbar(v,p,100+15,100+cosspace+(cosinc)-disp,tostring(SoapFetchConstant("soap_devmode")),SKINCOLOR_SUPERPURPLE2)
	else
		drawcosbar(v,p,100+15,100+cosspace+(cosinc)-disp,tostring(SoapFetchConstant("soap_devmode")),SKINCOLOR_PURPLE)
	end
	v.drawString(115+15, 100-25+(cosinc*2)-disp, "\x86N\x80 Soap Devmode",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	if SoapFetchConstant("soap_pvpnerf")
		drawcosbar(v,p,160+15,100+cosspace+(cosinc)-disp,"true",SKINCOLOR_JET)
	else
		drawcosbar(v,p,160+15,100+cosspace+(cosinc)-disp,"false",SKINCOLOR_CLOUDY)
	end
	v.drawString(175+15, 100-25+(cosinc*2)-disp, "\x86N\x80 PVP Nerf",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

	//last row
	if SoapMobjThinkerAllowed("ring_pull")
		drawcosbar(v,p,130+15,100+cosspace+(cosinc*2)-disp,"on",SKINCOLOR_GOLD)
	else
		drawcosbar(v,p,130+15,100+cosspace+(cosinc*2)-disp,"off",SKINCOLOR_SUPERRUST5)
	end
	v.drawString(145+15, 100-25+(cosinc*3)-disp, "\x86N\x80 Ring Pull",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

//PAGE 3
elseif soap.cosmenupage == 3
	if SoapFetchConstant("soap_blockmapsallowed")
		drawcosbar(v,p,100+15,100-cosspace-disp,SoapFetchConstant("soap_blockmapsallowed"),SKINCOLOR_ICY)
	else
		drawcosbar(v,p,100+15,100-cosspace-disp,SoapFetchConstant("soap_blockmapsallowed"),SKINCOLOR_COBALT)
	end
	v.drawString(115+15, 100-25-disp, "\x86N\x80 Blockmaps",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")
	
	if SoapFetchConstant("soap_performance")
		drawcosbar(v,p,160+15,100-cosspace-disp,tostring(SoapFetchConstant("soap_performance")),SKINCOLOR_EMERALD)
	else
		drawcosbar(v,p,160+15,100-cosspace-disp,tostring(SoapFetchConstant("soap_performance")),SKINCOLOR_FOREST)
	end
	v.drawString(175+15, 100-25-disp, "\x86N\x80 Perform.",V_ALLOWLOWERCASE|V_PERPLAYER, "thin-center")

end
	
	drawcosbar(v,p,85+15,190-disp,"Exit (C1)",SKINCOLOR_JET)
	
	//page indc.
	v.drawString(145+15, 195-disp, "Page "..(soap.cosmenupage+1).." of "..maxpage,V_ALLOWLOWERCASE|V_PERPLAYER, "small-center")
	
	//flip button
	if soap.cosmenupage == 0
		drawcosbar(v,p,175+15,190-disp,"Next (WN)",SKINCOLOR_CARBON,nil,nil,"small-center")	
	elseif soap.cosmenupage == 1
		if soap.isElevated
			drawcosbar(v,p,175+15,190-disp,"Flip (WN/WP)",SKINCOLOR_CARBON,nil,nil,"small-center")
		else
			drawcosbar(v,p,175+15,190-disp,"Prev. (WP)",SKINCOLOR_CARBON,nil,nil,"small-center")		
		end
	elseif soap.cosmenupage == 2
		drawcosbar(v,p,175+15,190-disp,"Flip (WN/WP)",SKINCOLOR_CARBON,nil,nil,"small-center")
	elseif soap.cosmenupage == 3
		drawcosbar(v,p,175+15,190-disp,"Prev. (WP)",SKINCOLOR_CARBON,nil,nil,"small-center")
	end
	
	local x
	local y
	if soap.cosmenucurx == 0
		if soap.cosmenupage ~= 0
			if soap.cosmenucury ~= 3
				x = 100
			elseif soap.cosmenucury == 3
				x = 130
			end
		else
			if soap.cosmenucury ~= 1
				x = 100
			elseif soap.cosmenucury == 1
				x = 130
			end		
		end
	else
		if soap.cosmenucury ~= 3
			x = 160
		//just in case
		elseif soap.cosmenucury == 3
			x = 130
		end
	end
	if soap.cosmenucury == 0
		y = 100-cosspace
	elseif soap.cosmenucury == 1
		y = 100+cosspace
	else
		y = 100+cosspace+(cosinc*(soap.cosmenucury-1))
	end
	
	drawcoscursor(v,p,x+15,y-disp)
end
local function DevmodeFlags(v, p)
//pflag stuff
v.drawString(100, 56, "Player Flags (In order listed on wiki)",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
if p.pflags & PF_FLIPCAM
	v.drawString(100, 60, "\x83"+"FC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(100, 60, "\x85"+"FC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_ANALOGMODE
	v.drawString(108+2, 60, "\x83"+"AM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(108+2, 60, "\x85"+"AM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_DIRECTIONCHAR
	v.drawString(116+4, 60, "\x83"+"DC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(116+4, 60, "\x85"+"DC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_AUTOBRAKE
	v.drawString(124+6, 60, "\x83"+"AB",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(124+6, 60, "\x85"+"AB",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_GODMODE
	v.drawString(132+8, 60, "\x83"+"GM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(132+8, 60, "\x85"+"GM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_NOCLIP
	v.drawString(140+10, 60, "\x83"+"NC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(140+10, 60, "\x85"+"NC",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_INVIS
	v.drawString(148+12, 60, "\x83"+"IN",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(148+12, 60, "\x85"+"IN",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_ATTACKDOWN
	v.drawString(156+14, 60, "\x83"+"AD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(156+14, 60, "\x85"+"AD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_SPINDOWN
	v.drawString(164+16, 60, "\x83"+"SD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(164+16, 60, "\x85"+"SD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_JUMPDOWN
	v.drawString(172+18, 60, "\x83"+"JD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(172+18, 60, "\x85"+"JD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_WPNDOWN
	v.drawString(180+20, 60, "\x83"+"WD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(180+20, 60, "\x85"+"WD",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_STASIS
	v.drawString(188+22, 60, "\x83"+"SS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(188+22, 60, "\x85"+"SS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_JUMPSTASIS
	v.drawString(196+26, 60, "\x83"+"JS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(196+26, 60, "\x85"+"JS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_FULLSTASIS
	v.drawString(204+28, 60, "\x83"+"FS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(204+28, 60, "\x85"+"FS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
//new  line
if p.pflags & PF_APPLYAUTOBRAKE
	v.drawString(100, 64, "\x83"+"AA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(100, 64, "\x85"+"AA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_STARTJUMP
	v.drawString(108+2, 64, "\x83"+"SJ",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(108+2, 64, "\x85"+"SJ",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_JUMPED
	v.drawString(116+4, 64, "\x83"+"JU",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(116+4, 64, "\x85"+"JU",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_NOJUMPDAMAGE
	v.drawString(124+6, 64, "\x83"+"ND",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(124+6, 64, "\x85"+"ND",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_SPINNING
	v.drawString(132+8, 64, "\x83"+"SP",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(132+8, 64, "\x85"+"SP",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_STARTDASH
	v.drawString(140+10, 64, "\x83"+"ST",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(140+10, 64, "\x85"+"ST",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_THOKKED
	v.drawString(148+12, 64, "\x83"+"TH",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(148+12, 64, "\x85"+"TH",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_SHIELDABILITY
	v.drawString(156+14, 64, "\x83"+"SA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(156+14, 64, "\x85"+"SA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end
if p.pflags & PF_GLIDING
	v.drawString(164+16, 64, "\x83"+"GL",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
else
	v.drawString(164+16, 64, "\x85"+"GL",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
end

if p.soaptable
	local soap = p.soaptable
	//soap booleans
	v.drawString(100,68, "Soap Booleans (In order listed in init.lua)",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	if soap.isDash
		v.drawString(100, 72, "\x83"+"DA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(100, 72, "\x85"+"DA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.onGround
		v.drawString(108+2, 72, "\x83"+"OG",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(108+2, 72, "\x85"+"OG",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isSoap
		v.drawString(116+4, 72, "\x83"+"IS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(116+4, 72, "\x85"+"IS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isValid
		v.drawString(124+6, 72, "\x83"+"VA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(124+6, 72, "\x85"+"VA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isIdle
		v.drawString(132+8, 72, "\x83"+"ID",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(132+8, 72, "\x85"+"ID",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isXmo
		v.drawString(140+10, 72, "\x83"+"XM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(140+10, 72, "\x85"+"XM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isXmoON
		v.drawString(148+12, 72, "\x83"+"XO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(148+12, 72, "\x85"+"XO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isSuper
		v.drawString(156+14, 72, "\x83"+"SU",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(156+14, 72, "\x85"+"SU",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isSuperM
		v.drawString(172+18, 72, "\x83"+"SM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(172+18, 72, "\x85"+"SM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isElevated
		v.drawString(180+20, 72, "\x83"+"EL",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(180+20, 72, "\x85"+"EL",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.inPain
		v.drawString(188+22, 72, "\x83"+"PA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(188+22, 72, "\x85"+"PA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.canADash
		v.drawString(196+24, 72, "\x83"+"CA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(196+24, 72, "\x85"+"CA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isSValid
		v.drawString(204+26, 72, "\x83"+"SV",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(204+26, 72, "\x85"+"SV",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	//new line
	if soap.noShield
		v.drawString(100, 76, "\x83"+"NS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(100, 76, "\x85"+"NS",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isSol
		v.drawString(108+2, 76, "\x83"+"SO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(108+2, 76, "\x85"+"SO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isTransform
		v.drawString(116+4, 76, "\x83"+"TR",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(116+4, 76, "\x85"+"TR",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isWatered
		v.drawString(124+6, 76, "\x83"+"WA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(124+6, 76, "\x85"+"WA",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isBoostm
		v.drawString(132+8, 76, "\x83"+"BM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(132+8, 76, "\x85"+"BM",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
	if soap.isGod
		v.drawString(140+10, 76, "\x83"+"GO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	else
		v.drawString(140+10, 76, "\x85"+"GO",V_50TRANS|V_ALLOWLOWERCASE|V_SNAPTORIGHT|V_SNAPTOTOP, "small")
	end
end
end
//sorry for this extremely long function!

//hud stuff for soap.devmode!!!!!!!!!!!!!!!!!!
//and maybe for some future stuff ;)
//local fttexty = 60
//local fttrans = 0
//with some from sms

//this is stupid
local shownNotif = false

//const
local cosspace = 15
local cosinc = 30
local disp = 20
//stupid hud thing v2
hud.add(function(v, p)
if not p.mo
return end

local mach4f = 0
local smflag = V_SNAPTORIGHT|V_SNAPTOBOTTOM|V_HUDTRANS|V_PERPLAYER

local speed1x = 0
local speed1y = 0
local speed1x2 = 0
local speed1y2 = 0
local speed1type = "right"
local speed1type2 = "thin-right"

local speed2x = 0
local speed2y = 0
local speed2x2 = 0
local speed2y2 = 0

local speednx = 0
local speedny = 0

if not p.soaptable
return
end

if (p.powers[pw_carry] == CR_NIGHTSMODE)
return
end

//cant do anything without these locals first!
local soap = p.soaptable
local me = p.mo

if soap.cosmenuopen
	drawcosmenu(v,p,soap,cosspace,cosinc,disp)
end

if me.skin == "soapthehedge"	
	
	if (not me.health)
//	or (p.exiting)
		return
	end

//EW I HATE THIS THING!!!
///////FT START
	//i know this thing is annoying, but i want people to know how to play as this fella!
	if soap.firsttime
	//its our first time playing
	and not soap.firstttic
	//we're not waiting for the text to show anymore
//	and soap.fttic
	//we're allowed to show the text
//	and not (soap.ftblink % 2 == 0)
	and soap.ftblink
	and not (soap.ftkill and soap.ftblink % 2 == 0)
	and not (soap.ftblink-2*TICRATE < 30 and soap.ftblink % 2 == 0)
	and not (p == secondarydisplayplayer)
		
		v.drawString(soap.ftx, soap.fty, "New to\x88 Soap\x80? Check out\x86 soap_help\x80 to learn the ins and outs of\x88 Soap\x80.",V_ALLOWLOWERCASE|V_PERPLAYER|V_HUDTRANS, "thin-center")
		v.drawString(soap.ftx, (soap.fty+12), "\x86Use soap_help in console or press C2 to close",V_50TRANS|V_ALLOWLOWERCASE|V_PERPLAYER, "small-center")
	end

	if (soap.Scustom2OS)
	and not soap.firstttic
	and (not soap.ftkill)
		soap.ftkill = TICRATE
	end
///////FT END


//ok! lets copy that c2 thing
	//c2 indicator to show shield abilities are binded to c2
	if not soap.noShield
	and soap.isSValid
	//next to life
	//	v.drawScaled(((hudinfo[HUD_LIVES].x*5)*FRACUNIT), 175*FRACUNIT, FRACUNIT/5, v.cachePatch("SOAPC2"), V_SNAPTOLEFT|V_SNAPTOBOTTOM,v.getColormap(nil, nil))
	//	v.drawString((hudinfo[HUD_LIVES].x*6)+2, hudinfo[HUD_LIVES].y+5, "Shield Ability",V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "small")
	//above life
		if not ((p.mrce) or (soap.isCloneF))
			v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT, (hudinfo[HUD_LIVES].y-20)*FRACUNIT, FRACUNIT/5, v.cachePatch("SOAPC2"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS,v.getColormap(nil, nil))
			if not ((RingSlinger) and (G_RingSlingerGametype()))
				v.drawString(hudinfo[HUD_LIVES].x+20, hudinfo[HUD_LIVES].y-14, "Shield Ability ("+(soap.hudshieldability)+")",V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS, "small")
			else
				//wrap for ringslinger neo
				v.drawString(hudinfo[HUD_LIVES].x+20, hudinfo[HUD_LIVES].y-16, "Shield Ability \n("+(soap.hudshieldability)+")",V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS, "small")
			end
		else //move up to account for mrce hud and for clonefighter
			v.drawScaled(hudinfo[HUD_LIVES].x*FRACUNIT, (hudinfo[HUD_LIVES].y-40)*FRACUNIT, FRACUNIT/5, v.cachePatch("SOAPC2"), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS,v.getColormap(nil, nil))
			v.drawString(hudinfo[HUD_LIVES].x+20, hudinfo[HUD_LIVES].y-34, "Shield Ability ("+(soap.hudshieldability)+")",V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS, "small")
		end
	end
//

//just look at your trail
/*
	if soap.airdashtimer
	and soap.airdashtimer <= 70
	and not soap.airdashed
		v.drawString(soap.ftx+135, soap.fty+60, 70-soap.airdashtimer+"/70",V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS, "small-center")
	end
*/

//yucky
//these are center aligned by default!
speed1x = 160+40
speed1y = hudinfo[HUD_LIVES].y-4
speed1type = "center"

speed1x2 = 160+40
speed1y2 = hudinfo[HUD_LIVES].y+2
speed1type2 = "thin-center"

speed2x = 155+35
speed2y = hudinfo[HUD_LIVES].y-4
speed2x2 = 166+35
speed2y2 = hudinfo[HUD_LIVES].y
	
speednx = 160+35
speedny = hudinfo[HUD_LIVES].y-2

if (not RingSlinger)
	//right-aligned
	speed1x = 315-60
	speed1x2 = 320-60
	speed1type = "right" 
	speed1type2 = "thin-right"

	speed2x = 155+125-60
	speed2y = hudinfo[HUD_LIVES].y-4
	speed2x2 = 166+125-60
	speed2y2 = hudinfo[HUD_LIVES].y
		
	speednx = 160+125-60
	speedny = hudinfo[HUD_LIVES].y-2

else
	//ringlinger neo
	if G_RingSlingerGametype()

		if soap.isFirstPerson
			smflag = $|V_SNAPTOLEFT &~V_SNAPTORIGHT
			if soap.isZE
				speed1y = $-45
				speed1y2 = $-45
				
				speed2y = $-45
				speed2y2 = $-45
				
				speedny = $-45
			else
				speed1y = $+12
				speed1y2 = $+12
				
				speed2y = $+13
				speed2y2 = $+13
				
				speedny = $+13				
			end
		else
			//right-aligned
			speed1x = 315-60
			speed1x2 = 320-60
			speed1type = "right" 
			speed1type2 = "thin-right"

			speed2x = 155+125-60
			speed2y = hudinfo[HUD_LIVES].y-4
			speed2x2 = 166+125-60
			speed2y2 = hudinfo[HUD_LIVES].y
				
			speednx = 160+125-60
			speedny = hudinfo[HUD_LIVES].y-2
		end
	else
		//right-aligned
		speed1x = 315-60
		speed1x2 = 320-60
		speed1type = "right" 
		speed1type2 = "thin-right"

		speed2x = 155+125-60
		speed2y = hudinfo[HUD_LIVES].y-4
		speed2x2 = 166+125-60
		speed2y2 = hudinfo[HUD_LIVES].y
			
		speednx = 160+125-60
		speedny = hudinfo[HUD_LIVES].y-2

	end
end

if soap.ptaicolor == 1	
	mach4f = V_REDMAP
else
	mach4f = V_GREENMAP
end

//ringslinger neo "viewmodel" covers this. too bad!
//add soap after ringslinger neo!
if soap.cosspeedometer
	if soap.cosspeedometer == 1
		v.drawString(speed1x, speed1y, soap.accSpeed, smflag, speed1type2)		
	//	v.drawString((hudinfo[HUD_LIVES].x*20)+14, hudinfo[HUD_LIVES].y-2, "/",smflag, "thin")
		v.drawString(speed1x2, speed1y2, p.normalspeed, smflag|V_YELLOWMAP, speed1type)
	elseif soap.cosspeedometer == 2
		v.drawString(speed2x, speed2y, soap.accSpeed/FRACUNIT, smflag, "thin-right")		
		v.drawString(speednx, speedny, "/",smflag, "thin")
		v.drawString(speed2x2, speed2y2, p.normalspeed/FRACUNIT, smflag|V_YELLOWMAP, "left")
	end
end

if p.powers[pw_underwater]
	drawammobar(v, p, me)
end


if p.dashmode >= 4*TICRATE
	v.drawString(160, 128, p.dashmode-((3*TICRATE)+4), V_HUDTRANS|V_ALLOWLOWERCASE|V_PERPLAYER|mach4f, "small-center")
end

//whoops!
if p.powers[pw_carry] == CR_PLAYER
	if me.tracer and me.tracer.player
		if (me.tracer.player.powers[pw_tailsfly] < 17) 
		and (me.tracer.player.charability == CA_FLY) 
		and (me.tracer.skin == "poyo")
		and not soap.helpedpoyo
			if (leveltime % 2 == 0)			
				v.drawString(soap.ftx, soap.fty+31, "\x85"+"Spin: Boost!",V_HUDTRANS|V_ALLOWLOWERCASE|V_PERPLAYER, "small-center")
			else
				v.drawString(soap.ftx, soap.fty+32, "\x83"+"Spin: Boost!",V_HUDTRANS|V_ALLOWLOWERCASE|V_PERPLAYER, "small-center")	
			end
		end
	end
end


if soap.divecancel
	if soap.divecancel <= 16
		drawdivecancelbar(v,p,me,soap)
		if soap.Scustom1DOWN
			v.drawString(175, 105, "C1: Air Boost",V_HUDTRANS|V_YELLOWMAP|V_ALLOWLOWERCASE|V_PERPLAYER, "small")
		else
			v.drawString(175, 105, "C1: Air Boost",V_50TRANS|V_ALLOWLOWERCASE|V_PERPLAYER, "small")
		end
	end
end

end //skin if

//show lag thing
if soap.isElevated
	if SoapIsLargeMap(23)
	and (not shownNotif)
			v.drawString(soap.ftx, soap.fty, "Experiecing lag?",V_ALLOWLOWERCASE|V_HUDTRANS, "thin-center")
			v.drawString(soap.ftx, soap.fty+12, " Try disabling MobjThinkers with "+"\x86"+"soap_mobjthinkers ring_pull "+"\x80"+"to ease the lag.",V_ALLOWLOWERCASE|V_HUDTRANS, "thin-center")
			v.drawString(soap.ftx, (soap.fty+24), "\x86Press Custom1 to dismiss this message.",V_30TRANS|V_ALLOWLOWERCASE, "small-center")
			if p.cmd.buttons & BT_CUSTOM1
			and (not shownNotif)
				shownNotif = true
			end
	elseif not SoapIsLargeMap(234)
		shownNotif = false
	end
end

//show how many YDs are chasing you!
if gametype == GT_YELLOWDEMON
or ((SoapFetchConstant("soap_yellowdemon")) and (me.skin == "soapthehedge"))
or SoapFetchConstant("soap_devmode")
or ((SoapFetchConstant("soap_yellowdemon")) and ((gametype == GT_COOP) and (not netgame)))
	v.drawScaled(((hudinfo[HUD_LIVES].x*5)*FRACUNIT)+(5*FRACUNIT), 189*FRACUNIT, FRACUNIT/2,v.getSpritePatch("RING", A, 0, 0), V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS|V_PERPLAYER)
	v.drawString((hudinfo[HUD_LIVES].x*6)+2, hudinfo[HUD_LIVES].y+5, soap.YDcount,V_ALLOWLOWERCASE|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS|V_PERPLAYER, "thin")
end

if soap.cosmenuwait
	drawcosmenuwaitbar(v,p,soap)
end



if soap.devmode
	DevmodeFlags(v, p)
	if soap.goobounce
		v.drawString(-10, 100-8-8, "Goobounce: "..soap.goobounce,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
	end
	if soap.airdashtimer
		v.drawString(-10, 100-8-8, "Airdash Timer: "..(70-soap.airdashtimer),V_ALLOWLOWERCASE|V_HUDTRANS, "thin")	
	end
	v.drawString(-10, 100-8, "Dashmode: "..p.dashmode,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")

	if soap.starteddive
		v.drawString(-10, 100, "divemomz: ("..soap.divemomz/FRACUNIT..") "..soap.divemomz,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
		v.drawString(-10, 108, "Blast Radius: ("..(abs(soap.divemomz)*10)/FRACUNIT..") "..abs(soap.divemomz)*10,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
		v.drawString(-10, 108+8, "Startup Anim Length: "..soap.diveanimstart,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
	end
	if soap.cosmenuopen
		v.drawString(-10, 100, "Controls: "..soap.cosmenuleft.." "..soap.cosmenuright.." "..soap.cosmenuup.." "..soap.cosmenudown,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
		v.drawString(-10, 108, "Page Controls: "..soap.cosmenuflipp.." "..soap.cosmenuflipn,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
		v.drawString(-10, 116, "Cursor: "..soap.cosmenucurx..", "..soap.cosmenucury,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
		v.drawString(-10, 132-8, "Selection: (soap_)"..soap.cosmenuselect,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
		v.drawString(-10, 140-8, "Page: "..soap.cosmenupage,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
		v.drawString(-10, 148-8, "Cooldown: "..soap.cosmenucooldown,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
	end
	if soap.bouncecount
		v.drawString(-10, 100, "Bouncing Down: "..soap.bounced,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
		v.drawString(-10, 100+8, "Bouncing Up: "..soap.bounceagain,V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
		v.drawString(-10, 100+8+8, "Bounce Count: "..soap.bouncecount/FRACUNIT.." Can Bounce? "..tostring((soap.bouncecount <= (8*FRACUNIT))),V_ALLOWLOWERCASE|V_HUDTRANS, "thin")
	end
end

end)

